diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-pss-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-pss-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-pss-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-pss-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -271,6 +271,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -430,7 +434,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "token bank fair queue" manner
+   * Check that the downlink assignment is done in a "token bank fair queue" manner
    */
 
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
@@ -452,7 +456,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "round robin" manner
+  * Check that the uplink assignment is done in a "round robin" manner
   */
 
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
@@ -520,7 +524,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
-
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -673,7 +680,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "token bank fair queue" manner
+   * Check that the downlink assignment is done in a "token bank fair queue" manner
    */
 
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s)");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-radio-link-failure.cc ns-3.31/src/lte/test/lte-test-radio-link-failure.cc
--- ns-3.30.1/src/lte/test/lte-test-radio-link-failure.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-radio-link-failure.cc	2020-06-27 17:38:30.000000000 -0700
@@ -159,6 +159,20 @@
   // LogComponentEnable ("LteEnbRrc", logLevel);
   // LogComponentEnable ("LteRadioLinkFailureTest", logLevel);
 
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlPdcpOutputFilename", StringValue (CreateTempDirFilename ("DlPdcpStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlPdcpOutputFilename", StringValue (CreateTempDirFilename ("UlPdcpStats.txt")));
+  Config::SetDefault ("ns3::PhyStatsCalculator::DlRsrpSinrFilename", StringValue (CreateTempDirFilename ("DlRsrpSinrStats.txt")));
+  Config::SetDefault ("ns3::PhyStatsCalculator::UlSinrFilename", StringValue (CreateTempDirFilename ("UlSinrStats.txt")));
+  Config::SetDefault ("ns3::PhyStatsCalculator::UlInterferenceFilename", StringValue (CreateTempDirFilename ("UlInterferenceStats.txt")));
+  Config::SetDefault ("ns3::PhyRxStatsCalculator::DlRxOutputFilename", StringValue (CreateTempDirFilename ("DlRxPhyStats.txt")));
+  Config::SetDefault ("ns3::PhyRxStatsCalculator::UlRxOutputFilename", StringValue (CreateTempDirFilename ("UlRxPhyStats.txt")));
+  Config::SetDefault ("ns3::PhyTxStatsCalculator::DlTxOutputFilename", StringValue (CreateTempDirFilename ("DlTxPhyStats.txt")));
+  Config::SetDefault ("ns3::PhyTxStatsCalculator::UlTxOutputFilename", StringValue (CreateTempDirFilename ("UlTxPhyStats.txt")));
+
   NS_LOG_FUNCTION (this << GetName ());
   uint16_t numBearersPerUe = 1;
   Time simTime = m_simTime;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-rr-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-rr-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-rr-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-rr-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -187,6 +187,10 @@
       Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));
     }
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (false));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   // This is needed as the RR scheduler does not allocate resources properly for retransmission
   Config::SetDefault ("ns3::LteRlcAm::TxOpportunityForRetxAlwaysBigEnough", BooleanValue (true));
@@ -262,7 +266,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the assignation is done in a RR fashion
+   * Check that the assignment is done in a RR fashion
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-tdbet-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-tdbet-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-tdbet-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-tdbet-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -211,6 +211,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   //Disable Uplink Power Control
   Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
@@ -284,7 +288,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "TD blind equal throughput" manner
+   * Check that the downlink assignment is done in a "TD blind equal throughput" manner
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
@@ -298,7 +302,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)dlDataRxed.at (i) << "  thr " << (double)dlDataRxed.at (i) / statsDuration << " ref " << m_thrRefDl);
     }
   /**
-  * Check that the assignation is done in a "TD blind equal throughput" manner among users
+  * Check that the assignment is done in a "TD blind equal throughput" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
@@ -309,7 +313,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "TD blind equal throughput" manner
+  * Check that the uplink assignment is done in a "TD blind equal throughput" manner
   */
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> ulDataRxed;
@@ -323,7 +327,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)ulDataRxed.at (i) << "  thr " << (double)ulDataRxed.at (i) / statsDuration << " ref " << m_thrRefUl);
     }
   /**
-  * Check that the assignation is done in a "TD blind equal throughput" manner among users
+  * Check that the assignment is done in a "TD blind equal throughput" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
@@ -381,6 +385,10 @@
       Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));
     }
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (false));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   /**
   * Initialize Simulation Scenario: 1 eNB and m_nUser UEs
@@ -469,7 +477,7 @@
   estTotalThr = m_nUser * (1 / estTotalThr);
   estUeThr = estTotalThr / m_nUser;
   /**
-  * Check that the assignation is done in a "TD blind equal throughput" manner among users
+  * Check that the assignment is done in a "TD blind equal throughput" manner among users
   * with different SINRs: the bandwidth should be distributed equally in long term
   */
   for (int i = 0; i < m_nUser; i++)
@@ -483,7 +491,7 @@
     }
 
   /**
-  * Check that the assignation in uplink is done in a round robin manner.
+  * Check that the assignment in uplink is done in a round robin manner.
   */
 
   NS_LOG_INFO ("UL - Test with " << m_nUser);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-tdmt-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-tdmt-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-tdmt-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-tdmt-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -191,6 +191,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   //Disable Uplink Power Control
   Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
@@ -264,7 +268,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "time domain maximum throughput" manner
+   * Check that the downlink assignment is done in a "time domain maximum throughput" manner
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
@@ -278,7 +282,7 @@
     }
 
   /**
-  * Check that the assignation is done in a "time domain maximum throughput" manner among users
+  * Check that the assignment is done in a "time domain maximum throughput" manner among users
   * with maximum SINRs: without fading, current FD MT always assign all resources to one UE
   */
 
@@ -300,7 +304,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "proportional fair" manner
+  * Check that the uplink assignment is done in a "proportional fair" manner
   */
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> ulDataRxed;
@@ -314,7 +318,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)ulDataRxed.at (i) << "  thr " << (double)ulDataRxed.at (i) / statsDuration << " ref " << m_thrRefUl);
     }
   /**
-  * Check that the assignation is done in a "proportional fair" manner among users
+  * Check that the assignment is done in a "proportional fair" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-tdtbfq-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-tdtbfq-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-tdtbfq-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-tdtbfq-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -270,6 +270,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -429,7 +433,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "token bank fair queue" manner
+   * Check that the downlink assignment is done in a "token bank fair queue" manner
    */
 
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
@@ -451,7 +455,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "round robin" manner
+  * Check that the uplink assignment is done in a "round robin" manner
   */
 
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
@@ -519,7 +523,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
-
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -678,7 +685,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "token bank fair queue" manner
+   * Check that the downlink assignment is done in a "token bank fair queue" manner
    */
 
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s)");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-tta-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-tta-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-tta-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-tta-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -194,6 +194,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   //Disable Uplink Power Control
   Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
@@ -267,7 +271,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "Throughput to Average" manner
+   * Check that the downlink assignment is done in a "Throughput to Average" manner
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
@@ -281,7 +285,7 @@
     }
 
   /**
-  * Check that the assignation is done in a "Throughput to Average" manner among users
+  * Check that the assignment is done in a "Throughput to Average" manner among users
   * with maximum SINRs: without fading, current FD MT always assign all resources to one UE
   */
 
@@ -303,7 +307,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "proportional fair" manner
+  * Check that the uplink assignment is done in a "proportional fair" manner
   */
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> ulDataRxed;
@@ -317,7 +321,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)ulDataRxed.at (i) << "  thr " << (double)ulDataRxed.at (i) / statsDuration << " ref " << m_thrRefUl);
     }
   /**
-  * Check that the assignation is done in a "proportional fair" manner among users
+  * Check that the assignment is done in a "proportional fair" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-ue-measurements.cc ns-3.31/src/lte/test/lte-test-ue-measurements.cc
--- ns-3.30.1/src/lte/test/lte-test-ue-measurements.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-ue-measurements.cc	2020-06-27 17:38:30.000000000 -0700
@@ -198,12 +198,12 @@
   lteHelper->ActivateDataRadioBearer (ueDevs2, bearer);
 
 
-  Config::Connect ("/NodeList/2/DeviceList/0/LteUePhy/ReportUeMeasurements",
+  Config::Connect ("/NodeList/2/DeviceList/0/ComponentCarrierMapUe/0/LteUePhy/ReportUeMeasurements",
                    MakeBoundCallback (&ReportUeMeasurementsCallback, this));
   Config::Connect ("/NodeList/0/DeviceList/0/LteEnbRrc/RecvMeasurementReport",
                    MakeBoundCallback (&RecvMeasurementReportCallback, this));
 
-  Config::Connect ("/NodeList/3/DeviceList/0/LteUePhy/ReportUeMeasurements",
+  Config::Connect ("/NodeList/3/DeviceList/0/ComponentCarrierMapUe/0/LteUePhy/ReportUeMeasurements",
                    MakeBoundCallback (&ReportUeMeasurementsCallback, this));
   Config::Connect ("/NodeList/1/DeviceList/0/LteEnbRrc/RecvMeasurementReport",
                    MakeBoundCallback (&RecvMeasurementReportCallback, this));
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-uplink-power-control.cc ns-3.31/src/lte/test/lte-test-uplink-power-control.cc
--- ns-3.30.1/src/lte/test/lte-test-uplink-power-control.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-uplink-power-control.cc	2020-06-27 17:38:30.000000000 -0700
@@ -207,7 +207,7 @@
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
 
-  uint8_t bandwidth = 25;
+  uint16_t bandwidth = 25;
   double d1 = 0;
 
   // Create Nodes: eNodeB and UE
@@ -321,7 +321,7 @@
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   lteHelper->SetFfrAlgorithmType ("ns3::LteFfrSimple");
 
-  uint8_t bandwidth = 25;
+  uint16_t bandwidth = 25;
   double d1 = 100;
 
   // Create Nodes: eNodeB and UE
@@ -434,7 +434,7 @@
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   lteHelper->SetFfrAlgorithmType ("ns3::LteFfrSimple");
 
-  uint8_t bandwidth = 25;
+  uint16_t bandwidth = 25;
   double d1 = 10;
 
   // Create Nodes: eNodeB and UE
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/test-lte-epc-e2e-data.cc ns-3.31/src/lte/test/test-lte-epc-e2e-data.cc
--- ns-3.30.1/src/lte/test/test-lte-epc-e2e-data.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/test-lte-epc-e2e-data.cc	2020-06-27 17:38:30.000000000 -0700
@@ -142,6 +142,10 @@
   Config::SetDefault ("ns3::LteSpectrumPhy::CtrlErrorModelEnabled", BooleanValue (false));
   Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));  
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlPdcpOutputFilename", StringValue (CreateTempDirFilename ("DlPdcpStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlPdcpOutputFilename", StringValue (CreateTempDirFilename ("UlPdcpStats.txt")));
+
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper> epcHelper = CreateObject<PointToPointEpcHelper> ();
   lteHelper->SetEpcHelper (epcHelper);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/wscript ns-3.31/src/lte/wscript
--- ns-3.30.1/src/lte/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -180,7 +180,6 @@
         'test/test-asn1-encoding.cc',
         'test/lte-test-ue-measurements.cc',
         'test/lte-test-cell-selection.cc',
-        'test/lte-test-secondary-cell-selection.cc',
         'test/test-lte-handover-delay.cc',
         'test/test-lte-handover-target.cc',
         'test/lte-test-deactivate-bearer.cc',
@@ -198,6 +197,12 @@
         'test/lte-test-radio-link-failure.cc',
         ]
 
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        module_test.source.extend([
+        #   'test/lte-examples-test-suite.cc',
+            ])
+        
     headers = bld(features='ns3header')
     headers.module = 'lte'
     headers.source = [
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mesh/bindings/callbacks_list.py ns-3.31/src/mesh/bindings/callbacks_list.py
--- ns-3.30.1/src/mesh/bindings/callbacks_list.py	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mesh/bindings/callbacks_list.py	2020-06-27 17:38:30.000000000 -0700
@@ -7,7 +7,7 @@
     ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'bool', 'ns3::Ptr<ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'unsigned short', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'unsigned char', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mesh/examples/mesh.cc ns-3.31/src/mesh/examples/mesh.cc
--- ns-3.30.1/src/mesh/examples/mesh.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mesh/examples/mesh.cc	2020-06-27 17:38:30.000000000 -0700
@@ -131,7 +131,7 @@
 void
 MeshTest::Configure (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("x-size", "Number of nodes in a row grid", m_xSize);
   cmd.AddValue ("y-size", "Number of rows in a grid", m_ySize);
   cmd.AddValue ("step",   "Size of edge in our grid (meters)", m_step);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mesh/helper/mesh-helper.cc ns-3.31/src/mesh/helper/mesh-helper.cc
--- ns-3.30.1/src/mesh/helper/mesh-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mesh/helper/mesh-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -27,6 +27,7 @@
 #include "ns3/minstrel-wifi-manager.h"
 #include "ns3/mesh-wifi-interface-mac.h"
 #include "ns3/wifi-helper.h"
+#include "ns3/wifi-ack-policy-selector.h"
 
 namespace ns3
 {
@@ -119,6 +120,10 @@
   MeshHelper helper;
   helper.SetMacType ();
   helper.SetRemoteStationManager ("ns3::ArfWifiManager");
+  helper.SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector");
+  helper.SetAckPolicySelectorForAc (AC_BK, "ns3::ConstantWifiAckPolicySelector");
+  helper.SetAckPolicySelectorForAc (AC_VI, "ns3::ConstantWifiAckPolicySelector");
+  helper.SetAckPolicySelectorForAc (AC_VO, "ns3::ConstantWifiAckPolicySelector");
   helper.SetSpreadInterfaceChannels (SPREAD_CHANNELS);
   return helper;
 }
@@ -165,6 +170,28 @@
   m_stationManager.Set (n6, v6);
   m_stationManager.Set (n7, v7);
 }
+void
+MeshHelper::SetAckPolicySelectorForAc (AcIndex ac, std::string type,
+                                       std::string n0, const AttributeValue &v0,
+                                       std::string n1, const AttributeValue &v1,
+                                       std::string n2, const AttributeValue &v2,
+                                       std::string n3, const AttributeValue &v3,
+                                       std::string n4, const AttributeValue &v4,
+                                       std::string n5, const AttributeValue &v5,
+                                       std::string n6, const AttributeValue &v6,
+                                       std::string n7, const AttributeValue &v7)
+{
+  m_ackPolicySelector[ac] = ObjectFactory ();
+  m_ackPolicySelector[ac].SetTypeId (type);
+  m_ackPolicySelector[ac].Set (n0, v0);
+  m_ackPolicySelector[ac].Set (n1, v1);
+  m_ackPolicySelector[ac].Set (n2, v2);
+  m_ackPolicySelector[ac].Set (n3, v3);
+  m_ackPolicySelector[ac].Set (n4, v4);
+  m_ackPolicySelector[ac].Set (n5, v5);
+  m_ackPolicySelector[ac].Set (n6, v6);
+  m_ackPolicySelector[ac].Set (n7, v7);
+}
 void 
 MeshHelper::SetStandard (enum WifiPhyStandard standard)
 {
@@ -191,6 +218,30 @@
   device->SetRemoteStationManager (manager);
   node->AddDevice (device);
   mac->SwitchFrequencyChannel (channelId);
+  // Install ack policy selector
+  PointerValue ptr;
+  Ptr<WifiAckPolicySelector> ackSelector;
+
+  mac->GetAttributeFailSafe ("BE_Txop", ptr);
+  ackSelector = m_ackPolicySelector[AC_BE].Create<WifiAckPolicySelector> ();
+  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
+
+  mac->GetAttributeFailSafe ("BK_Txop", ptr);
+  ackSelector = m_ackPolicySelector[AC_BK].Create<WifiAckPolicySelector> ();
+  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
+
+  mac->GetAttributeFailSafe ("VI_Txop", ptr);
+  ackSelector = m_ackPolicySelector[AC_VI].Create<WifiAckPolicySelector> ();
+  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
+
+  mac->GetAttributeFailSafe ("VO_Txop", ptr);
+  ackSelector = m_ackPolicySelector[AC_VO].Create<WifiAckPolicySelector> ();
+  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
+
   return device;
 }
 void
